"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var lizard_py_1 = require("lizard-py");
var defaultConfigLinter = {
    ignoreChars: [
        {
            startWith: '\\/\\*',
            endWith: '\\*\\/',
        },
        {
            startWith: "\"",
            endWith: "\"",
            replace: "\"\"",
        },
        {
            startWith: "'",
            endWith: "'",
            replace: "''",
        },
        {
            startWith: '\\/\\/',
            endWith: '\\n',
        },
        {
            startWith: " \\{",
            replace: "{",
        },
    ],
};
function classworkLinter(source, filename, config) {
    return __awaiter(this, void 0, void 0, function () {
        var x, chars, stringRegex, regex_1, regex, response, cyclomaticComplexity, x, f, methods;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!config) {
                        config = __assign({}, defaultConfigLinter);
                    }
                    else {
                        config = __assign(__assign(__assign({}, defaultConfigLinter), config), { ignoreChars: config.ignoreChars ? config.ignoreChars : defaultConfigLinter.ignoreChars });
                    }
                    if (typeof source !== 'string') {
                        try {
                            source = source.join('\n');
                        }
                        catch (e) {
                            source = source.toString();
                        }
                    }
                    for (x in config.ignoreChars) {
                        chars = config.ignoreChars[x];
                        stringRegex = chars.endWith ? "(" + chars.startWith + ")(.+?)(" + chars.endWith + ")" : "(" + chars.startWith + ")";
                        regex_1 = new RegExp(stringRegex, 'gs');
                        source = source.replace(regex_1, chars.replace ? chars.replace : '');
                    }
                    regex = new RegExp('}', 'g');
                    source = source.replace(regex, '};');
                    return [4 /*yield*/, lizard_py_1.analyzeSourceCode(filename, source)];
                case 1:
                    response = (_a.sent());
                    cyclomaticComplexity = 0;
                    for (x in response.function_list) {
                        f = response.function_list[x];
                        cyclomaticComplexity += f.cyclomatic_complexity;
                    }
                    methods = response.function_list.map(function (item) {
                        var funcName = item.long_name.replace(/\( /gs, '(').replace(/\[ /gs, '[');
                        return {
                            name: item.name,
                            longName: funcName,
                            cyclomaticComplexity: item.cyclomatic_complexity,
                            startLine: item.start_line,
                            endLine: item.end_line,
                            parameters: item.parameters,
                            filename: item.filename,
                            topNestingLevel: item.top_nesting_level,
                            length: item.length,
                            fanIn: item.fan_in,
                            fanOut: item.fan_out,
                            generalFanOut: item.general_fan_out,
                        };
                    });
                    return [2 /*return*/, {
                            qtdLines: response.nloc,
                            qtdMethods: response.function_list.length,
                            cyclomaticComplexity: cyclomaticComplexity,
                            token: response.token_count,
                            methods: methods,
                            source: source,
                        }];
            }
        });
    });
}
exports.default = classworkLinter;
